window.Gleam.initSearch([{"doc":"aoc_2024","title":"aoc_2024","content":"[![github actions](https://github.com/tiborpilz/aoc_2024/actions/workflows/test.yml/badge.svg)](https://github.com/tiborpilz/aoc_2024/actions/workflows/test.yml)\n\n# aoc_2024\n\nSolutions for Advent of Code 2024 in Gleam.\n\nDocumentation: [https://tiborpilz.github.io/aoc_2024/](https://tiborpilz.github.io/aoc_2024/)\n\n## Usage:\n\n```sh\ngleam run day_5 # Run the solution for day 5\n```\n\n## Details\n\nEach day&#39;s solution is implemented in a seperate module, e.g. `day_1`: [day_1](./src/day_1.gleam)\n\nTo help with some solutions, this project uses a shared `grid` module, see: [grid](./grid.html)\n\nAdditionally, some shared functionality is implemented in the `utils` module, see: [utils](./utils.html)\n","url":"index.html"},{"doc":"utils","title":"add_prefix","content":"pub fn add_prefix(s: String, prefix: String) -&gt; String\n\nSynonyms:\nutils.add_prefix\nutils add_prefix","url":"utils.html#add_prefix"},{"doc":"utils","title":"at","content":"pub fn at(data: List(a), index: Int) -&gt; Result(a, Nil)\n Gets the entry of a 1D-List at a given index\nSynonyms:\nutils.at\nutils at","url":"utils.html#at"},{"doc":"utils","title":"format_int","content":"pub fn format_int(n: Int) -&gt; String\n\nSynonyms:\nutils.format_int\nutils format_int","url":"utils.html#format_int"},{"doc":"utils","title":"format_sum","content":"pub fn format_sum(l: List(Int), prefix: String) -&gt; String\n\nSynonyms:\nutils.format_sum\nutils format_sum","url":"utils.html#format_sum"},{"doc":"utils","title":"join","content":"pub fn join(chars: List(String)) -&gt; String\n\nSynonyms:\nutils.join\nutils join","url":"utils.html#join"},{"doc":"utils","title":"main","content":"pub fn main() -&gt; List(String)\n\nSynonyms:\nutils.main\nutils main","url":"utils.html#main"},{"doc":"utils","title":"parse_entry","content":"pub fn parse_entry(entry: String) -&gt; Int\n\nSynonyms:\nutils.parse_entry\nutils parse_entry","url":"utils.html#parse_entry"},{"doc":"utils","title":"parse_row","content":"pub fn parse_row(line: String) -&gt; List(Int)\n\nSynonyms:\nutils.parse_row\nutils parse_row","url":"utils.html#parse_row"},{"doc":"utils","title":"print_with_part","content":"pub fn print_with_part(result: String, part: String) -&gt; Nil\n\nSynonyms:\nutils.print_with_part\nutils print_with_part","url":"utils.html#print_with_part"},{"doc":"utils","title":"read","content":"pub fn read(filepath: String) -&gt; String\n\nSynonyms:\nutils.read\nutils read","url":"utils.html#read"},{"doc":"utils","title":"read_chars","content":"pub fn read_chars(filepath: String) -&gt; List(List(String))\n Reads a file line by line and splits the rows into individual characters\nSynonyms:\nutils.read_chars\nutils read_chars","url":"utils.html#read_chars"},{"doc":"utils","title":"read_lines","content":"pub fn read_lines(filepath: String) -&gt; List(String)\n\nSynonyms:\nutils.read_lines\nutils read_lines","url":"utils.html#read_lines"},{"doc":"utils","title":"split_by_empty_row","content":"pub fn split_by_empty_row(\n  input: List(String),\n) -&gt; List(List(String))\n Given a list of strings, return a list of lists of strings,\n seperated by empty rows\nSynonyms:\nutils.split_by_empty_row\nutils split_by_empty_row","url":"utils.html#split_by_empty_row"},{"doc":"utils","title":"sum","content":"pub fn sum(l: List(Int)) -&gt; Int\n\nSynonyms:\nutils.sum\nutils sum","url":"utils.html#sum"},{"doc":"utils","title":"to_string","content":"pub fn to_string(n: Int) -&gt; String\n\nSynonyms:\nutils.to_string\nutils to_string","url":"utils.html#to_string"},{"doc":"utils","title":"utils","content":"","url":"utils.html"},{"doc":"day_1","title":"get_data","content":"pub fn get_data() -&gt; #(List(Int), List(Int))\n\nSynonyms:\nday_1.get_data\nday_1 get_data","url":"day_1.html#get_data"},{"doc":"day_1","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nday_1.main\nday_1 main","url":"day_1.html#main"},{"doc":"day_1","title":"parse_entry","content":"pub fn parse_entry(entry: String) -&gt; Int\n\nSynonyms:\nday_1.parse_entry\nday_1 parse_entry","url":"day_1.html#parse_entry"},{"doc":"day_1","title":"parse_row","content":"pub fn parse_row(line: String) -&gt; List(Int)\n\nSynonyms:\nday_1.parse_row\nday_1 parse_row","url":"day_1.html#parse_row"},{"doc":"day_1","title":"part_1","content":"pub fn part_1() -&gt; Nil\n\nSynonyms:\nday_1.part_1\nday_1 part_1","url":"day_1.html#part_1"},{"doc":"day_1","title":"part_2","content":"pub fn part_2() -&gt; Nil\n\nSynonyms:\nday_1.part_2\nday_1 part_2","url":"day_1.html#part_2"},{"doc":"day_1","title":"day_1","content":" Day 1\n\n For part 1, we can use the builtin `list.zip` function to pair up the two lists\n and then get the absolute difference between the two numbers in each pair.\n The result can then be summed.\n\n For part 2, we take each element of the left list and sort the right list by the\n distance to calculate a per-element similarity (which can then be summed again).","url":"day_1.html"},{"doc":"grid","title":"Element","content":"pub type Element(a) =\n  #(Position, a)\n A single element value together with its position.\n\nSynonyms:\ngrid.Element\ngrid Element","url":"grid.html#Element"},{"doc":"grid","title":"Grid","content":"pub type Grid(a) =\n  dict.Dict(Position, a)\n A grid is a dictionary with the keys being the a tuple of y,x coordinates of the elements.\n\nSynonyms:\ngrid.Grid\ngrid Grid","url":"grid.html#Grid"},{"doc":"grid","title":"Position","content":"pub type Position =\n  #(Int, Int)\n A position is given as a tuple of coordinates: (y, x)\n\nSynonyms:\ngrid.Position\ngrid Position","url":"grid.html#Position"},{"doc":"grid","title":"from_lists","content":"pub fn from_lists(lists: List(List(a))) -&gt; Dict(#(Int, Int), a)\n\n Takes a m⨯n list of lists and returns a Grid - which is a dictionary with the keys being the\n a tuple of i,j indices of the elements.\nSynonyms:\ngrid.from_lists\ngrid from_lists","url":"grid.html#from_lists"},{"doc":"grid","title":"get","content":"pub fn get(\n  grid: Dict(#(Int, Int), a),\n  indices: #(Int, Int),\n) -&gt; Result(a, Nil)\n\n Get value specified by indices\n\nSynonyms:\ngrid.get\ngrid get","url":"grid.html#get"},{"doc":"grid","title":"get_column","content":"pub fn get_column(\n  grid: Dict(#(Int, Int), a),\n  index: Int,\n) -&gt; Result(List(a), Nil)\n\n Gets the column of a given index as a list\nSynonyms:\ngrid.get_column\ngrid get_column","url":"grid.html#get_column"},{"doc":"grid","title":"get_indexed_column","content":"pub fn get_indexed_column(\n  grid: Dict(#(Int, Int), a),\n  index: Int,\n) -&gt; Result(List(#(#(Int, Int), a)), Nil)\n\n Gets the column of a given index as a list of tuples of indices value\nSynonyms:\ngrid.get_indexed_column\ngrid get_indexed_column","url":"grid.html#get_indexed_column"},{"doc":"grid","title":"get_indexed_row","content":"pub fn get_indexed_row(\n  grid: Dict(#(Int, Int), a),\n  index: Int,\n) -&gt; Result(List(#(#(Int, Int), a)), Nil)\n\n Gets the row of a given index as a list of tuples of indices and values\nSynonyms:\ngrid.get_indexed_row\ngrid get_indexed_row","url":"grid.html#get_indexed_row"},{"doc":"grid","title":"get_row","content":"pub fn get_row(\n  grid: Dict(#(Int, Int), a),\n  index: Int,\n) -&gt; Result(List(a), Nil)\n\n Gets the row of a given index as a list\nSynonyms:\ngrid.get_row\ngrid get_row","url":"grid.html#get_row"},{"doc":"grid","title":"position_to_string","content":"pub fn position_to_string(position: #(Int, Int)) -&gt; String\n\n Transforms a given position to string (for debug purposes)\nSynonyms:\ngrid.position_to_string\ngrid position_to_string","url":"grid.html#position_to_string"},{"doc":"grid","title":"pretty_print","content":"pub fn pretty_print(\n  grid: Dict(#(Int, Int), String),\n) -&gt; Dict(#(Int, Int), String)\n\n Given a Grid of Strings, pretty prints it\nSynonyms:\ngrid.pretty_print\ngrid pretty_print","url":"grid.html#pretty_print"},{"doc":"grid","title":"size","content":"pub fn size(grid: Dict(#(Int, Int), a)) -&gt; #(Int, Int)\n\n Gets the height and width of a given Grid as a tuple #(height, width)\nSynonyms:\ngrid.size\ngrid size","url":"grid.html#size"},{"doc":"grid","title":"to_col_list_indexed","content":"pub fn to_col_list_indexed(\n  grid: Dict(#(Int, Int), a),\n) -&gt; List(List(#(#(Int, Int), a)))\n\n Transforms a grid to a list of list of tuples of indices and values (column-wise)\nSynonyms:\ngrid.to_col_list_indexed\ngrid to_col_list_indexed","url":"grid.html#to_col_list_indexed"},{"doc":"grid","title":"to_lists","content":"pub fn to_lists(grid: Dict(#(Int, Int), a)) -&gt; List(List(a))\n\n Transforms a grid to a list of lists (row-wise)\nSynonyms:\ngrid.to_lists\ngrid to_lists","url":"grid.html#to_lists"},{"doc":"grid","title":"to_row_list_indexed","content":"pub fn to_row_list_indexed(\n  grid: Dict(#(Int, Int), a),\n) -&gt; List(List(#(#(Int, Int), a)))\n\n Transforms a grid to a list of lists of tuples of indices and values (row-wise)\nSynonyms:\ngrid.to_row_list_indexed\ngrid to_row_list_indexed","url":"grid.html#to_row_list_indexed"},{"doc":"grid","title":"update_if_exists","content":"pub fn update_if_exists(\n  grid: Dict(#(Int, Int), a),\n  indices: #(Int, Int),\n  value: a,\n) -&gt; Dict(#(Int, Int), a)\n\n Updates a given entry (specified by a tuple of indices) only if it already\n exists.\nSynonyms:\ngrid.update_if_exists\ngrid update_if_exists","url":"grid.html#update_if_exists"},{"doc":"grid","title":"grid","content":" The grid module provides a two-dimensional data structure.\n It is implemented as a dictionary with the keys being the\n a tuple of i,j indices of the elements.","url":"grid.html"},{"doc":"day_10","title":"get_paths","content":"pub fn get_paths(\n  grid: Dict(#(Int, Int), Int),\n  position: #(Int, Int),\n  current_path: List(#(Int, Int)),\n  paths: List(List(#(Int, Int))),\n) -&gt; List(List(#(Int, Int)))\n\nSynonyms:\nday_10.get_paths\nday_10 get_paths","url":"day_10.html#get_paths"},{"doc":"day_10","title":"get_start_positions","content":"pub fn get_start_positions(\n  grid: Dict(#(Int, Int), Int),\n) -&gt; List(#(Int, Int))\n\nSynonyms:\nday_10.get_start_positions\nday_10 get_start_positions","url":"day_10.html#get_start_positions"},{"doc":"day_10","title":"get_surrounding_entries","content":"pub fn get_surrounding_entries(\n  grid: Dict(#(Int, Int), Int),\n  position: #(Int, Int),\n) -&gt; List(#(Int, Int))\n\nSynonyms:\nday_10.get_surrounding_entries\nday_10 get_surrounding_entries","url":"day_10.html#get_surrounding_entries"},{"doc":"day_10","title":"get_trailheads","content":"pub fn get_trailheads(\n  grid: Dict(#(Int, Int), Int),\n) -&gt; List(#(Int, Int))\n\nSynonyms:\nday_10.get_trailheads\nday_10 get_trailheads","url":"day_10.html#get_trailheads"},{"doc":"day_10","title":"get_unique_endpoints","content":"pub fn get_unique_endpoints(\n  paths: List(List(#(Int, Int))),\n) -&gt; List(#(Int, Int))\n\nSynonyms:\nday_10.get_unique_endpoints\nday_10 get_unique_endpoints","url":"day_10.html#get_unique_endpoints"},{"doc":"day_10","title":"grid_to_string","content":"pub fn grid_to_string(\n  grid: Dict(#(Int, Int), Int),\n) -&gt; Dict(#(Int, Int), String)\n\nSynonyms:\nday_10.grid_to_string\nday_10 grid_to_string","url":"day_10.html#grid_to_string"},{"doc":"day_10","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nday_10.main\nday_10 main","url":"day_10.html#main"},{"doc":"day_10","title":"day_10","content":"","url":"day_10.html"},{"doc":"day_11","title":"add_to_with_default","content":"pub fn add_to_with_default(\n  input: Dict(Int, Int),\n  key: Int,\n  value: Int,\n) -&gt; Dict(Int, Int)\n\nSynonyms:\nday_11.add_to_with_default\nday_11 add_to_with_default","url":"day_11.html#add_to_with_default"},{"doc":"day_11","title":"count_entries","content":"pub fn count_entries(input: Dict(Int, Int)) -&gt; Int\n\nSynonyms:\nday_11.count_entries\nday_11 count_entries","url":"day_11.html#count_entries"},{"doc":"day_11","title":"get_num_digits","content":"pub fn get_num_digits(input: Int) -&gt; Int\n\nSynonyms:\nday_11.get_num_digits\nday_11 get_num_digits","url":"day_11.html#get_num_digits"},{"doc":"day_11","title":"list_to_dict","content":"pub fn list_to_dict(input: List(Int)) -&gt; Dict(Int, Int)\n\nSynonyms:\nday_11.list_to_dict\nday_11 list_to_dict","url":"day_11.html#list_to_dict"},{"doc":"day_11","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nday_11.main\nday_11 main","url":"day_11.html#main"},{"doc":"day_11","title":"mutate_element","content":"pub fn mutate_element(input: Int) -&gt; List(Int)\n\nSynonyms:\nday_11.mutate_element\nday_11 mutate_element","url":"day_11.html#mutate_element"},{"doc":"day_11","title":"mutate_list","content":"pub fn mutate_list(\n  input: List(Int),\n  times: Int,\n  memoized: Dict(#(Int, Int), List(Int)),\n) -&gt; List(Int)\n\nSynonyms:\nday_11.mutate_list\nday_11 mutate_list","url":"day_11.html#mutate_list"},{"doc":"day_11","title":"process_element","content":"pub fn process_element(\n  input: Int,\n  times: Int,\n  memoized: Dict(#(Int, Int), List(Int)),\n) -&gt; #(List(Int), Dict(#(Int, Int), List(Int)))\n\nSynonyms:\nday_11.process_element\nday_11 process_element","url":"day_11.html#process_element"},{"doc":"day_11","title":"process_line_out_of_order","content":"pub fn process_line_out_of_order(\n  input: Dict(Int, Int),\n  count: Int,\n) -&gt; Dict(Int, Int)\n\nSynonyms:\nday_11.process_line_out_of_order\nday_11 process_line_out_of_order","url":"day_11.html#process_line_out_of_order"},{"doc":"day_11","title":"split_digits","content":"pub fn split_digits(input: Int) -&gt; List(Int)\n Given a number 1234, return two numbers 12, 34. Assumes the number\n has an even amount of digits.\nSynonyms:\nday_11.split_digits\nday_11 split_digits","url":"day_11.html#split_digits"},{"doc":"day_11","title":"update_and_return","content":"pub fn update_and_return(\n  dict: Dict(a, b),\n  key: a,\n  value: b,\n) -&gt; #(b, Dict(a, b))\n\nSynonyms:\nday_11.update_and_return\nday_11 update_and_return","url":"day_11.html#update_and_return"},{"doc":"day_11","title":"day_11","content":"","url":"day_11.html"},{"doc":"day_12","title":"accumulate_border","content":"pub fn accumulate_border(\n  grid: Dict(#(Int, Int), String),\n  current: #(Int, Int),\n  border: List(#(Int, Int)),\n  initial_cell: #(Int, Int),\n) -&gt; List(#(Int, Int))\n\nSynonyms:\nday_12.accumulate_border\nday_12 accumulate_border","url":"day_12.html#accumulate_border"},{"doc":"day_12","title":"find_adjacent_element","content":"pub fn find_adjacent_element(\n  cell: #(Int, Int),\n  from: List(#(Int, Int)),\n) -&gt; Result(#(#(Int, Int), List(#(Int, Int))), Nil)\n\nSynonyms:\nday_12.find_adjacent_element\nday_12 find_adjacent_element","url":"day_12.html#find_adjacent_element"},{"doc":"day_12","title":"find_first_border_cell","content":"pub fn find_first_border_cell(\n  grid: Dict(#(Int, Int), String),\n  region: List(#(Int, Int)),\n) -&gt; #(Int, Int)\n\nSynonyms:\nday_12.find_first_border_cell\nday_12 find_first_border_cell","url":"day_12.html#find_first_border_cell"},{"doc":"day_12","title":"find_next_border_cell","content":"pub fn find_next_border_cell(\n  grid: Dict(#(Int, Int), String),\n  cell: #(Int, Int),\n) -&gt; #(Int, Int)\n\nSynonyms:\nday_12.find_next_border_cell\nday_12 find_next_border_cell","url":"day_12.html#find_next_border_cell"},{"doc":"day_12","title":"get_adjacent_cells","content":"pub fn get_adjacent_cells(pos: #(Int, Int)) -&gt; List(#(Int, Int))\n Get the adjacent cells\n\n oAo\n AXA\n oAo\n\n For the cell &quot;X&quot; in the middle, the adjacent cells are the ones that can be\n reached by moving one step in any vertical or horizontal direction.\n The 4 cross-shaped cells &quot;A&quot; are the adjacent cells.\nSynonyms:\nday_12.get_adjacent_cells\nday_12 get_adjacent_cells","url":"day_12.html#get_adjacent_cells"},{"doc":"day_12","title":"get_circumference","content":"pub fn get_circumference(\n  grid: Dict(#(Int, Int), String),\n  region: List(#(Int, Int)),\n) -&gt; Int\n Get the circumference for the given region.\n Note that this assumes contiguousness.\n Each cell adds a value based on the number of neighbors it has\n that are in the region. 4 neighbors -&gt; 0 circumference, 3 neighbors -&gt; 1, etc.\nSynonyms:\nday_12.get_circumference\nday_12 get_circumference","url":"day_12.html#get_circumference"},{"doc":"day_12","title":"get_region","content":"pub fn get_region(\n  grid: Dict(#(Int, Int), String),\n  candidate_pos: #(Int, Int),\n  current_value: String,\n  checked_cells: Dict(#(Int, Int), Bool),\n) -&gt; #(List(#(Int, Int)), Dict(#(Int, Int), Bool))\n\nSynonyms:\nday_12.get_region\nday_12 get_region","url":"day_12.html#get_region"},{"doc":"day_12","title":"get_same_adjacents","content":"pub fn get_same_adjacents(\n  grid: Dict(#(Int, Int), String),\n  cell: #(Int, Int),\n) -&gt; List(#(Int, Int))\n Get adjacent cells with the same value\nSynonyms:\nday_12.get_same_adjacents\nday_12 get_same_adjacents","url":"day_12.html#get_same_adjacents"},{"doc":"day_12","title":"get_same_surrounding","content":"pub fn get_same_surrounding(\n  grid: Dict(#(Int, Int), String),\n  cell: #(Int, Int),\n) -&gt; List(#(Int, Int))\n Get surrounding cells with the same value\nSynonyms:\nday_12.get_same_surrounding\nday_12 get_same_surrounding","url":"day_12.html#get_same_surrounding"},{"doc":"day_12","title":"get_surrounding_cells","content":"pub fn get_surrounding_cells(\n  pos: #(Int, Int),\n) -&gt; List(#(Int, Int))\n Get the surrounding cells (both direct and diagonal)\n\n oAo\n AXA\n oAo\n\n here, the surrounding cells for &quot;X&quot; in the middle are all 8 cells around it.\n [&quot;o&quot;, &quot;A&quot;, &quot;o&quot;, &quot;A&quot;, &quot;A&quot;, &quot;A&quot;, &quot;o&quot;, &quot;A&quot;]\nSynonyms:\nday_12.get_surrounding_cells\nday_12 get_surrounding_cells","url":"day_12.html#get_surrounding_cells"},{"doc":"day_12","title":"has_checked","content":"pub fn has_checked(\n  regions: List(List(#(Int, Int))),\n  candidate: #(Int, Int),\n) -&gt; Bool\n\nSynonyms:\nday_12.has_checked\nday_12 has_checked","url":"day_12.html#has_checked"},{"doc":"day_12","title":"is_border_cell","content":"pub fn is_border_cell(\n  grid: Dict(#(Int, Int), String),\n  cell: #(Int, Int),\n) -&gt; Bool\n\nSynonyms:\nday_12.is_border_cell\nday_12 is_border_cell","url":"day_12.html#is_border_cell"},{"doc":"day_12","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nday_12.main\nday_12 main","url":"day_12.html#main"},{"doc":"day_12","title":"sort_boundary","content":"pub fn sort_boundary(\n  current_boundary: List(#(Int, Int)),\n  rest_boundary: List(#(Int, Int)),\n) -&gt; List(#(Int, Int))\n\nSynonyms:\nday_12.sort_boundary\nday_12 sort_boundary","url":"day_12.html#sort_boundary"},{"doc":"day_12","title":"day_12","content":"","url":"day_12.html"},{"doc":"day_13","title":"ClawMachine","content":"pub type ClawMachine {\n  ClawMachine(a: Position, b: Position, prize: Position)\n}\n A claw machine consist of three tuples of integers:\n - The x and y movement of button A\n - The x and y movement of button B\n - The x and y coordinates of the prize\nClawMachine(a: Position, b: Position, prize: Position)\n\n\nSynonyms:\nday_13.ClawMachine\nday_13 ClawMachine","url":"day_13.html#ClawMachine"},{"doc":"day_13","title":"Position","content":"pub type Position {\n  Position(x: Int, y: Int)\n}\n X,Y Position\nPosition(x: Int, y: Int)\n\n\nSynonyms:\nday_13.Position\nday_13 Position","url":"day_13.html#Position"},{"doc":"day_13","title":"add_to_position","content":"pub fn add_to_position(\n  position: Position,\n  value: Int,\n) -&gt; Position\n\nSynonyms:\nday_13.add_to_position\nday_13 add_to_position","url":"day_13.html#add_to_position"},{"doc":"day_13","title":"get_data","content":"pub fn get_data(prize_offset: Int) -&gt; List(ClawMachine)\n\nSynonyms:\nday_13.get_data\nday_13 get_data","url":"day_13.html#get_data"},{"doc":"day_13","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nday_13.main\nday_13 main","url":"day_13.html#main"},{"doc":"day_13","title":"parse_block","content":"pub fn parse_block(\n  block: List(String),\n  prize_offset: Int,\n) -&gt; Result(ClawMachine, Nil)\n Parse a block containing three lines (&#39;Button A:&#39;, &#39;Button B:&#39; &amp; Prize:)\nSynonyms:\nday_13.parse_block\nday_13 parse_block","url":"day_13.html#parse_block"},{"doc":"day_13","title":"parse_button","content":"pub fn parse_button(line: String) -&gt; Result(Position, Nil)\n Parse a line containing button information\nSynonyms:\nday_13.parse_button\nday_13 parse_button","url":"day_13.html#parse_button"},{"doc":"day_13","title":"parse_input","content":"pub fn parse_input(\n  lines: List(String),\n  result: List(Result(ClawMachine, Nil)),\n  prize_offset: Int,\n) -&gt; List(Result(ClawMachine, Nil))\n Parse lines of text into a list of ClawMachines\nSynonyms:\nday_13.parse_input\nday_13 parse_input","url":"day_13.html#parse_input"},{"doc":"day_13","title":"parse_prize","content":"pub fn parse_prize(\n  line: String,\n  prize_offset: Int,\n) -&gt; Result(Position, Nil)\n Parse a line containing Prize information\nSynonyms:\nday_13.parse_prize\nday_13 parse_prize","url":"day_13.html#parse_prize"},{"doc":"day_13","title":"part_1","content":"pub fn part_1() -&gt; Int\n\nSynonyms:\nday_13.part_1\nday_13 part_1","url":"day_13.html#part_1"},{"doc":"day_13","title":"part_2","content":"pub fn part_2() -&gt; Int\n\nSynonyms:\nday_13.part_2\nday_13 part_2","url":"day_13.html#part_2"},{"doc":"day_13","title":"solve_machine","content":"pub fn solve_machine(machine: ClawMachine) -&gt; Int\n Solve the linear equation given by `a_count * (a.x, a.y) + b_count * (b.x, b.y) = (prize.x, prize.y)`\n After solving, double check whether the solutions fit or wheter there&#39;s a rounding error.\n Then, return the score of the solution as speficied. (`3 * a_count + b_count`)\nSynonyms:\nday_13.solve_machine\nday_13 solve_machine","url":"day_13.html#solve_machine"},{"doc":"day_13","title":"strings_to_position","content":"pub fn strings_to_position(\n  raw_x: String,\n  raw_y: String,\n) -&gt; Result(Position, Nil)\n Parse two strings into a positon\nSynonyms:\nday_13.strings_to_position\nday_13 strings_to_position","url":"day_13.html#strings_to_position"},{"doc":"day_13","title":"day_13","content":"\n [Advent of Code day 13](https://adventofcode.com/2024/day/13)\n\n ## Parsing\n First, we need to split the lines into blocks\n describing each claw machine.\n We can do this by splitting the input by the empty line.\n Next, we need to parse each block. This is easily done by\n 1. assuming that each block has three lines\n 2. some regex.\n\n ## Checking for solvability\n To decide whether a claw machine can be solved, we need to find out\n whether the vector of the prize can be formed by\n any linear combination of the vectors described by button A and B\n (And whether the sum of the linear factors is less than 100).\n\n ## Finding the optimal path\n Finally, to find the optimal path (linear combination), we can take\n the list of all possible combinations and sort it by assigning scores\n to each linear combination:\n - Three times the linear factor of A + the linear factor of B\n The linear combination with the lowest score is our optimal path.\n\n k * ax + l * bx = x\n k * ay + l * by = y\n ( ax bx ) times (k) = (x)\n ( ay by )       (l)   (y)\n x * by -y * bx = k * ax*by - ay*by)\n y * ax - x * ay = l * (ax*by - ay*bx)","url":"day_13.html"},{"doc":"day_14","title":"Robot","content":"pub type Robot {\n  Robot(pos: Vec2, vel: Vec2)\n}\n\nRobot(pos: Vec2, vel: Vec2)\n\n\nSynonyms:\nday_14.Robot\nday_14 Robot","url":"day_14.html#Robot"},{"doc":"day_14","title":"Space","content":"pub type Space {\n  Space(width: Int, height: Int)\n}\n\nSpace(width: Int, height: Int)\n\n\nSynonyms:\nday_14.Space\nday_14 Space","url":"day_14.html#Space"},{"doc":"day_14","title":"Vec2","content":"pub type Vec2 {\n  Vec2(x: Int, y: Int)\n}\n\nVec2(x: Int, y: Int)\n\n\nSynonyms:\nday_14.Vec2\nday_14 Vec2","url":"day_14.html#Vec2"},{"doc":"day_14","title":"get_quadrant_counts","content":"pub fn get_quadrant_counts(\n  robots: List(Robot),\n  space: Space,\n) -&gt; #(Int, Int, Int, Int)\n\nSynonyms:\nday_14.get_quadrant_counts\nday_14 get_quadrant_counts","url":"day_14.html#get_quadrant_counts"},{"doc":"day_14","title":"get_quadrants","content":"pub fn get_quadrants(\n  robots: List(Robot),\n  space: Space,\n) -&gt; List(List(Robot))\n\nSynonyms:\nday_14.get_quadrants\nday_14 get_quadrants","url":"day_14.html#get_quadrants"},{"doc":"day_14","title":"highest_row_count","content":"pub fn highest_row_count(robots: List(Robot)) -&gt; Int\n\nSynonyms:\nday_14.highest_row_count\nday_14 highest_row_count","url":"day_14.html#highest_row_count"},{"doc":"day_14","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nday_14.main\nday_14 main","url":"day_14.html#main"},{"doc":"day_14","title":"move_robot","content":"pub fn move_robot(\n  robot: Robot,\n  seconds: Int,\n  space: Space,\n) -&gt; Robot\n\nSynonyms:\nday_14.move_robot\nday_14 move_robot","url":"day_14.html#move_robot"},{"doc":"day_14","title":"parse_robot","content":"pub fn parse_robot(line: String) -&gt; Robot\n\nSynonyms:\nday_14.parse_robot\nday_14 parse_robot","url":"day_14.html#parse_robot"},{"doc":"day_14","title":"print_quadrants","content":"pub fn print_quadrants(\n  quadrants: List(List(Robot)),\n  space: Space,\n  seconds: Int,\n) -&gt; List(List(Robot))\n\nSynonyms:\nday_14.print_quadrants\nday_14 print_quadrants","url":"day_14.html#print_quadrants"},{"doc":"day_14","title":"print_robots","content":"pub fn print_robots(\n  robots: List(Robot),\n  space: Space,\n  seconds: Int,\n) -&gt; List(Robot)\n\nSynonyms:\nday_14.print_robots\nday_14 print_robots","url":"day_14.html#print_robots"},{"doc":"day_14","title":"day_14","content":"","url":"day_14.html"},{"doc":"day_15","title":"Direction","content":"pub type Direction {\n  Up\n  Right\n  Down\n  Left\n}\n\nUp\n\n\nRight\n\n\nDown\n\n\nLeft\n\n\nSynonyms:\nday_15.Direction\nday_15 Direction","url":"day_15.html#Direction"},{"doc":"day_15","title":"Map","content":"pub type Map =\n  grid.Grid(MapTile)\n\n\nSynonyms:\nday_15.Map\nday_15 Map","url":"day_15.html#Map"},{"doc":"day_15","title":"MapTile","content":"pub type MapTile {\n  Wall\n  Empty\n  Robot\n  Box\n}\n\nWall\n\n\nEmpty\n\n\nRobot\n\n\nBox\n\n\nSynonyms:\nday_15.MapTile\nday_15 MapTile","url":"day_15.html#MapTile"},{"doc":"day_15","title":"debug_map","content":"pub fn debug_map(map: Dict(#(Int, Int), MapTile)) -&gt; List(String)\n\nSynonyms:\nday_15.debug_map\nday_15 debug_map","url":"day_15.html#debug_map"},{"doc":"day_15","title":"direction_to_string","content":"pub fn direction_to_string(direction: Direction) -&gt; String\n\nSynonyms:\nday_15.direction_to_string\nday_15 direction_to_string","url":"day_15.html#direction_to_string"},{"doc":"day_15","title":"get_boxes_to_move","content":"pub fn get_boxes_to_move(\n  path: List(#(#(Int, Int), MapTile)),\n) -&gt; List(#(#(Int, Int), MapTile))\n\nSynonyms:\nday_15.get_boxes_to_move\nday_15 get_boxes_to_move","url":"day_15.html#get_boxes_to_move"},{"doc":"day_15","title":"get_new_position","content":"pub fn get_new_position(\n  position: #(Int, Int),\n  direction: Direction,\n) -&gt; #(Int, Int)\n\nSynonyms:\nday_15.get_new_position\nday_15 get_new_position","url":"day_15.html#get_new_position"},{"doc":"day_15","title":"get_robot_col","content":"pub fn get_robot_col(\n  map: Dict(#(Int, Int), MapTile),\n) -&gt; List(#(#(Int, Int), MapTile))\n\nSynonyms:\nday_15.get_robot_col\nday_15 get_robot_col","url":"day_15.html#get_robot_col"},{"doc":"day_15","title":"get_robot_path","content":"pub fn get_robot_path(\n  line: List(#(#(Int, Int), MapTile)),\n) -&gt; List(#(#(Int, Int), MapTile))\n\nSynonyms:\nday_15.get_robot_path\nday_15 get_robot_path","url":"day_15.html#get_robot_path"},{"doc":"day_15","title":"get_robot_position","content":"pub fn get_robot_position(\n  map: Dict(#(Int, Int), MapTile),\n) -&gt; #(Int, Int)\n\nSynonyms:\nday_15.get_robot_position\nday_15 get_robot_position","url":"day_15.html#get_robot_position"},{"doc":"day_15","title":"get_robot_row","content":"pub fn get_robot_row(\n  map: Dict(#(Int, Int), MapTile),\n) -&gt; List(#(#(Int, Int), MapTile))\n\nSynonyms:\nday_15.get_robot_row\nday_15 get_robot_row","url":"day_15.html#get_robot_row"},{"doc":"day_15","title":"get_score","content":"pub fn get_score(map: Dict(#(Int, Int), MapTile)) -&gt; List(Int)\n\nSynonyms:\nday_15.get_score\nday_15 get_score","url":"day_15.html#get_score"},{"doc":"day_15","title":"is_next_space_empty","content":"pub fn is_next_space_empty(\n  path: List(#(#(Int, Int), MapTile)),\n) -&gt; Bool\n\nSynonyms:\nday_15.is_next_space_empty\nday_15 is_next_space_empty","url":"day_15.html#is_next_space_empty"},{"doc":"day_15","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nday_15.main\nday_15 main","url":"day_15.html#main"},{"doc":"day_15","title":"move_boxes","content":"pub fn move_boxes(\n  map: Dict(#(Int, Int), MapTile),\n  direction: Direction,\n  boxes: List(#(#(Int, Int), MapTile)),\n) -&gt; Dict(#(Int, Int), MapTile)\n\nSynonyms:\nday_15.move_boxes\nday_15 move_boxes","url":"day_15.html#move_boxes"},{"doc":"day_15","title":"move_robot","content":"pub fn move_robot(\n  map: Dict(#(Int, Int), MapTile),\n  direction: Direction,\n) -&gt; Dict(#(Int, Int), MapTile)\n\nSynonyms:\nday_15.move_robot\nday_15 move_robot","url":"day_15.html#move_robot"},{"doc":"day_15","title":"parse_direction","content":"pub fn parse_direction(input: String) -&gt; Direction\n\nSynonyms:\nday_15.parse_direction\nday_15 parse_direction","url":"day_15.html#parse_direction"},{"doc":"day_15","title":"parse_input","content":"pub fn parse_input(\n  input: List(String),\n) -&gt; #(Dict(#(Int, Int), MapTile), List(Direction))\n\nSynonyms:\nday_15.parse_input\nday_15 parse_input","url":"day_15.html#parse_input"},{"doc":"day_15","title":"parse_tile","content":"pub fn parse_tile(input: String) -&gt; MapTile\n\nSynonyms:\nday_15.parse_tile\nday_15 parse_tile","url":"day_15.html#parse_tile"},{"doc":"day_15","title":"to_string","content":"pub fn to_string(tile: MapTile) -&gt; String\n\nSynonyms:\nday_15.to_string\nday_15 to_string","url":"day_15.html#to_string"},{"doc":"day_15","title":"try_direction","content":"pub fn try_direction(\n  map: Dict(#(Int, Int), MapTile),\n  direction: Direction,\n) -&gt; Dict(#(Int, Int), MapTile)\n\nSynonyms:\nday_15.try_direction\nday_15 try_direction","url":"day_15.html#try_direction"},{"doc":"day_15","title":"update_map","content":"pub fn update_map(\n  map: Dict(#(Int, Int), MapTile),\n  directions: List(Direction),\n) -&gt; Dict(#(Int, Int), MapTile)\n\nSynonyms:\nday_15.update_map\nday_15 update_map","url":"day_15.html#update_map"},{"doc":"day_15","title":"day_15","content":"","url":"day_15.html"},{"doc":"day_16","title":"Direction","content":"pub type Direction {\n  North\n  East\n  South\n  West\n  None\n}\n\nNorth\n\n\nEast\n\n\nSouth\n\n\nWest\n\n\nNone\n\n\nSynonyms:\nday_16.Direction\nday_16 Direction","url":"day_16.html#Direction"},{"doc":"day_16","title":"Map","content":"pub type Map =\n  grid.Grid(Tile)\n\n\nSynonyms:\nday_16.Map\nday_16 Map","url":"day_16.html#Map"},{"doc":"day_16","title":"Path","content":"pub type Path =\n  List(grid.Position)\n\n\nSynonyms:\nday_16.Path\nday_16 Path","url":"day_16.html#Path"},{"doc":"day_16","title":"Tile","content":"pub type Tile {\n  Empty\n  Wall\n  Start\n  End\n}\n\nEmpty\n\n\nWall\n\n\nStart\n\n\nEnd\n\n\nSynonyms:\nday_16.Tile\nday_16 Tile","url":"day_16.html#Tile"},{"doc":"day_16","title":"debug_result","content":"pub fn debug_result(\n  result_tuple: #(\n    List(#(Int, List(#(Int, Int)))),\n    Dict(#(Int, Int), List(#(Int, List(#(Int, Int))))),\n  ),\n) -&gt; #(\n  List(#(Int, List(#(Int, Int)))),\n  Dict(#(Int, Int), List(#(Int, List(#(Int, Int))))),\n)\n\nSynonyms:\nday_16.debug_result\nday_16 debug_result","url":"day_16.html#debug_result"},{"doc":"day_16","title":"get_end_position","content":"pub fn get_end_position(\n  map: Dict(#(Int, Int), Tile),\n) -&gt; #(Int, Int)\n Get end position of a given map.\nSynonyms:\nday_16.get_end_position\nday_16 get_end_position","url":"day_16.html#get_end_position"},{"doc":"day_16","title":"get_paths","content":"pub fn get_paths(\n  map: Dict(#(Int, Int), Tile),\n  current_position: #(Int, Int),\n  current_direction: Direction,\n  current_path: List(#(Int, Int)),\n  current_score: Int,\n  paths: List(#(Int, List(#(Int, Int)))),\n  already_checked: Dict(#(Int, Int), Bool),\n  target_position: #(Int, Int),\n) -&gt; List(#(Int, List(#(Int, Int))))\n\nSynonyms:\nday_16.get_paths\nday_16 get_paths","url":"day_16.html#get_paths"},{"doc":"day_16","title":"get_possible_steps","content":"pub fn get_possible_steps(\n  map: Dict(#(Int, Int), Tile),\n  position: #(Int, Int),\n) -&gt; List(#(#(Int, Int), Direction))\n Given a position, get all possible next steps, (i.e not a wall, start, or out of bounds)\nSynonyms:\nday_16.get_possible_steps\nday_16 get_possible_steps","url":"day_16.html#get_possible_steps"},{"doc":"day_16","title":"get_scores","content":"pub fn get_scores(\n  map: Dict(#(Int, Int), Tile),\n  current_position: #(Int, Int),\n  current_direction: Direction,\n  current_path: List(#(Int, Int)),\n  current_score: Int,\n  scores: List(Int),\n  already_checked: Dict(#(Int, Int), Bool),\n  target_position: #(Int, Int),\n  counter: Int,\n) -&gt; List(Int)\n\nSynonyms:\nday_16.get_scores\nday_16 get_scores","url":"day_16.html#get_scores"},{"doc":"day_16","title":"get_scores_memoized","content":"pub fn get_scores_memoized(\n  map: Dict(#(Int, Int), Tile),\n  current_position: #(Int, Int),\n  current_direction: Direction,\n  current_path: List(#(Int, Int)),\n  current_score: Int,\n  scores: List(Int),\n  already_checked: Dict(#(Int, Int), Bool),\n  target_position: #(Int, Int),\n  known_scores: Dict(#(Int, Int), List(Int)),\n) -&gt; #(List(Int), Dict(#(Int, Int), List(Int)))\n\nSynonyms:\nday_16.get_scores_memoized\nday_16 get_scores_memoized","url":"day_16.html#get_scores_memoized"},{"doc":"day_16","title":"get_start_position","content":"pub fn get_start_position(\n  map: Dict(#(Int, Int), Tile),\n) -&gt; #(Int, Int)\n Get start position of a given map.\nSynonyms:\nday_16.get_start_position\nday_16 get_start_position","url":"day_16.html#get_start_position"},{"doc":"day_16","title":"get_step_cost","content":"pub fn get_step_cost(\n  current_direction: Direction,\n  next_direction: Direction,\n) -&gt; Int\n\nSynonyms:\nday_16.get_step_cost\nday_16 get_step_cost","url":"day_16.html#get_step_cost"},{"doc":"day_16","title":"get_surrounding_positions","content":"pub fn get_surrounding_positions(\n  position: #(Int, Int),\n) -&gt; List(#(#(Int, Int), Direction))\n Get all surrounding positions (in a cross pattern) of a given position.\nSynonyms:\nday_16.get_surrounding_positions\nday_16 get_surrounding_positions","url":"day_16.html#get_surrounding_positions"},{"doc":"day_16","title":"get_tile_position","content":"pub fn get_tile_position(\n  map: Dict(#(Int, Int), Tile),\n  tile: Tile,\n) -&gt; #(Int, Int)\n Find the first coordinates corresponding to a specific tile\n (only  really  useful for start and end, as they appear exactly once)\nSynonyms:\nday_16.get_tile_position\nday_16 get_tile_position","url":"day_16.html#get_tile_position"},{"doc":"day_16","title":"heuristic_score","content":"pub fn heuristic_score(\n  current_position: #(Int, Int),\n  target_position: #(Int, Int),\n) -&gt; Int\n If we&#39;re not on the same x or y line, assume we have to turn once (i.e. that there are no walls)\nSynonyms:\nday_16.heuristic_score\nday_16 heuristic_score","url":"day_16.html#heuristic_score"},{"doc":"day_16","title":"is_start","content":"pub fn is_start(\n  map: Dict(#(Int, Int), Tile),\n  position: #(Int, Int),\n) -&gt; Bool\n Given a position, check if it is the start\nSynonyms:\nday_16.is_start\nday_16 is_start","url":"day_16.html#is_start"},{"doc":"day_16","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nday_16.main\nday_16 main","url":"day_16.html#main"},{"doc":"day_16","title":"parse_map","content":"pub fn parse_map(\n  input: List(List(String)),\n) -&gt; Dict(#(Int, Int), Tile)\n\nSynonyms:\nday_16.parse_map\nday_16 parse_map","url":"day_16.html#parse_map"},{"doc":"day_16","title":"parse_tile","content":"pub fn parse_tile(char: String) -&gt; Tile\n\nSynonyms:\nday_16.parse_tile\nday_16 parse_tile","url":"day_16.html#parse_tile"},{"doc":"day_16","title":"print_path","content":"pub fn print_path(\n  path: List(#(Int, Int)),\n  map: Dict(#(Int, Int), Tile),\n) -&gt; List(#(Int, Int))\n\nSynonyms:\nday_16.print_path\nday_16 print_path","url":"day_16.html#print_path"},{"doc":"day_16","title":"stringify_map","content":"pub fn stringify_map(\n  map: Dict(#(Int, Int), Tile),\n) -&gt; Dict(#(Int, Int), String)\n\nSynonyms:\nday_16.stringify_map\nday_16 stringify_map","url":"day_16.html#stringify_map"},{"doc":"day_16","title":"tile_to_string","content":"pub fn tile_to_string(tile: Tile) -&gt; String\n\nSynonyms:\nday_16.tile_to_string\nday_16 tile_to_string","url":"day_16.html#tile_to_string"},{"doc":"day_16","title":"day_16","content":"","url":"day_16.html"},{"doc":"day_2","title":"ascending","content":"pub fn ascending(l: List(Int)) -&gt; Bool\n Returns true if all successive pairs of elements in list are ascending\nSynonyms:\nday_2.ascending\nday_2 ascending","url":"day_2.html#ascending"},{"doc":"day_2","title":"compare_pairwise","content":"pub fn compare_pairwise(\n  l: List(Int),\n  comparator: fn(Int, Int) -&gt; Bool,\n) -&gt; Bool\n Returns true if all successive pairs of elements in list satisfy the comparator\n and are within a safe distance\nSynonyms:\nday_2.compare_pairwise\nday_2 compare_pairwise","url":"day_2.html#compare_pairwise"},{"doc":"day_2","title":"descending","content":"pub fn descending(l: List(Int)) -&gt; Bool\n Returns true if all successive pairs of elements in list are descending\nSynonyms:\nday_2.descending\nday_2 descending","url":"day_2.html#descending"},{"doc":"day_2","title":"get_sublists","content":"pub fn get_sublists(l: List(Int)) -&gt; List(List(Int))\n Given a list of integers of length n, return n distinct, same-ordered sublists of length n-1\nSynonyms:\nday_2.get_sublists\nday_2 get_sublists","url":"day_2.html#get_sublists"},{"doc":"day_2","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nday_2.main\nday_2 main","url":"day_2.html#main"},{"doc":"day_2","title":"monotonic","content":"pub fn monotonic(l: List(Int)) -&gt; Bool\n Returns true if list is either ascending or descending\nSynonyms:\nday_2.monotonic\nday_2 monotonic","url":"day_2.html#monotonic"},{"doc":"day_2","title":"part_1","content":"pub fn part_1() -&gt; String\n\nSynonyms:\nday_2.part_1\nday_2 part_1","url":"day_2.html#part_1"},{"doc":"day_2","title":"part_2","content":"pub fn part_2() -&gt; String\n\nSynonyms:\nday_2.part_2\nday_2 part_2","url":"day_2.html#part_2"},{"doc":"day_2","title":"safe_dist","content":"pub fn safe_dist(a: Int, b: Int) -&gt; Bool\n Returns true if difference between parameters is within safe range (1 - 3)\nSynonyms:\nday_2.safe_dist\nday_2 safe_dist","url":"day_2.html#safe_dist"},{"doc":"day_2","title":"day_2","content":" Part 1 is more or less straightforward. The interesting thing is the pairwise comparison\n with a given comparator, making `ascending(l)` and `descending(l)` possible without\n too much code duplication.\n\n The more elegant approach could&#39;ve been to infer whether the list is ascending or descending\n by comparing the first and second elements, and then using that to determine the comparator.\n This way, we&#39;re checking the list twice, but hey, what&#39;s a factor of two between friends?\n Part 2 is a bit more tricky. The techniques are mostly the same as the one used in part 1, save\n for allowing one constraint violation per row. For that, this solution uses brute force to generate\n all possible distinct sublists of same ordering and length n-1, checks all of them for monotonicity\n and safe distances and then passes if any of them pass.\n The more efficient way to solve this would be to keep count of the number of\n unsafe distances/monotonicity violations in the list during the entire comparison, and allow one.\n That would still allow for pairwise comparisons and thus be O(n).","url":"day_2.html"},{"doc":"day_3","title":"get_mult_sum","content":"pub fn get_mult_sum(s: String) -&gt; Int\n Parse a string and return the sum of the products defined by `mul(a, b)` expressions\nSynonyms:\nday_3.get_mult_sum\nday_3 get_mult_sum","url":"day_3.html#get_mult_sum"},{"doc":"day_3","title":"load_rows","content":"pub fn load_rows() -&gt; String\n\nSynonyms:\nday_3.load_rows\nday_3 load_rows","url":"day_3.html#load_rows"},{"doc":"day_3","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nday_3.main\nday_3 main","url":"day_3.html#main"},{"doc":"day_3","title":"part_1","content":"pub fn part_1() -&gt; String\n\nSynonyms:\nday_3.part_1\nday_3 part_1","url":"day_3.html#part_1"},{"doc":"day_3","title":"part_2","content":"pub fn part_2() -&gt; String\n\nSynonyms:\nday_3.part_2\nday_3 part_2","url":"day_3.html#part_2"},{"doc":"day_3","title":"remove_dont_blocks","content":"pub fn remove_dont_blocks(input_string: String) -&gt; String\n Remove everything between a `don&#39;t()` and a `do()`, spanning multiple lines\nSynonyms:\nday_3.remove_dont_blocks\nday_3 remove_dont_blocks","url":"day_3.html#remove_dont_blocks"},{"doc":"day_3","title":"day_3","content":" For part 1, matching all regexes like `mul(1,4)`, capturing the numbers and then\n summing the products is enough.\n\n For part 2, we can non-greedily match everything between `don&#39;t()` and `do()` (or line end)\n and replace that with an empty string, as we don&#39;t want to consider those blocks.\n This leaves us with the same problem as part 1, which means we can reuse the same function.","url":"day_3.html"},{"doc":"day_4","title":"at","content":"pub fn at(data: List(a), index: Int) -&gt; Result(a, Nil)\n Gets the entry of a 1D-List at a given index\nSynonyms:\nday_4.at\nday_4 at","url":"day_4.html#at"},{"doc":"day_4","title":"at_xy","content":"pub fn at_xy(data: List(List(a)), y: Int, x: Int) -&gt; a\n Gets the entry at a 2D-List given xy index\nSynonyms:\nday_4.at_xy\nday_4 at_xy","url":"day_4.html#at_xy"},{"doc":"day_4","title":"check","content":"pub fn check(chars: List(String)) -&gt; Int\n\nSynonyms:\nday_4.check\nday_4 check","url":"day_4.html#check"},{"doc":"day_4","title":"count_crosses","content":"pub fn count_crosses(crosses: List(List(String))) -&gt; Int\n\nSynonyms:\nday_4.count_crosses\nday_4 count_crosses","url":"day_4.html#count_crosses"},{"doc":"day_4","title":"get_chunks","content":"pub fn get_chunks(\n  data: List(List(String)),\n  chunk_size: Int,\n) -&gt; List(List(List(String)))\n Get nxn chunks from a bigger mxm grid\nSynonyms:\nday_4.get_chunks\nday_4 get_chunks","url":"day_4.html#get_chunks"},{"doc":"day_4","title":"get_crosses","content":"pub fn get_crosses(\n  data: List(List(String)),\n) -&gt; List(List(String))\n Gets all 3-line Crosses from a given grid\nSynonyms:\nday_4.get_crosses\nday_4 get_crosses","url":"day_4.html#get_crosses"},{"doc":"day_4","title":"get_data","content":"pub fn get_data() -&gt; List(List(String))\n\nSynonyms:\nday_4.get_data\nday_4 get_data","url":"day_4.html#get_data"},{"doc":"day_4","title":"get_diagonals","content":"pub fn get_diagonals(\n  data: List(List(String)),\n) -&gt; List(List(String))\n Gets all 4 line diagonals from a given grid\nSynonyms:\nday_4.get_diagonals\nday_4 get_diagonals","url":"day_4.html#get_diagonals"},{"doc":"day_4","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nday_4.main\nday_4 main","url":"day_4.html#main"},{"doc":"day_4","title":"part_1","content":"pub fn part_1() -&gt; Int\n\nSynonyms:\nday_4.part_1\nday_4 part_1","url":"day_4.html#part_1"},{"doc":"day_4","title":"part_2","content":"pub fn part_2() -&gt; Int\n\nSynonyms:\nday_4.part_2\nday_4 part_2","url":"day_4.html#part_2"},{"doc":"day_4","title":"day_4","content":" The general idea is to split the incoming lines into a 2D array of single characters,\n then we can iterate over sliding windows of 4 characters horizontally, vertically\n and diagonally and check for &quot;XMAS&quot; ans &quot;SAMX&quot; in these windows, adding to the count.\n\n Part 2 is very similar, only we check each element&#39;s cross value which we first get as\n a list of list of strings.\n\n (This solution would benefit from using the shared `grid` module, but I haven&#39;t built that at that time).","url":"day_4.html"},{"doc":"day_5","title":"check_page","content":"pub fn check_page(\n  page: List(Int),\n  rules: List(#(Int, Int)),\n) -&gt; Bool\n Empty and 1 element lists are always valid\n For the others, check if the first element satisfies all rules with the rest of the list (pairwise)\n and then check the rest of the list\nSynonyms:\nday_5.check_page\nday_5 check_page","url":"day_5.html#check_page"},{"doc":"day_5","title":"get_valid_pages","content":"pub fn get_valid_pages(data: List(String)) -&gt; List(List(Int))\n Given a list of pages and rules, return the pages that satisfy all rules\nSynonyms:\nday_5.get_valid_pages\nday_5 get_valid_pages","url":"day_5.html#get_valid_pages"},{"doc":"day_5","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nday_5.main\nday_5 main","url":"day_5.html#main"},{"doc":"day_5","title":"parse_data","content":"pub fn parse_data(\n  data: List(String),\n) -&gt; #(List(List(Int)), List(#(Int, Int)))\n Given the initial data (already as lines) parse the data to a tuple of a list of\n pages and a list of rules.\nSynonyms:\nday_5.parse_data\nday_5 parse_data","url":"day_5.html#parse_data"},{"doc":"day_5","title":"parse_pages","content":"pub fn parse_pages(page: String) -&gt; List(Int)\n Given a page, parse the page to a list of integers.\nSynonyms:\nday_5.parse_pages\nday_5 parse_pages","url":"day_5.html#parse_pages"},{"doc":"day_5","title":"parse_rule","content":"pub fn parse_rule(rule: String) -&gt; #(Int, Int)\n Given a rule line, parse a rule in format of &quot;a|b&quot; to a tuple of #(b, a).\n This is because we use the rule to check for validations, meaning we need to reverse the order.\nSynonyms:\nday_5.parse_rule\nday_5 parse_rule","url":"day_5.html#parse_rule"},{"doc":"day_5","title":"part_1","content":"pub fn part_1() -&gt; Int\n\nSynonyms:\nday_5.part_1\nday_5 part_1","url":"day_5.html#part_1"},{"doc":"day_5","title":"part_2","content":"pub fn part_2() -&gt; Int\n\nSynonyms:\nday_5.part_2\nday_5 part_2","url":"day_5.html#part_2"},{"doc":"day_5","title":"rest_satisfies_all_rules","content":"pub fn rest_satisfies_all_rules(\n  a: Int,\n  rest: List(Int),\n  rules: List(#(Int, Int)),\n) -&gt; Bool\n Does the provided list of integers satisfy all rules pairwise?\nSynonyms:\nday_5.rest_satisfies_all_rules\nday_5 rest_satisfies_all_rules","url":"day_5.html#rest_satisfies_all_rules"},{"doc":"day_5","title":"sort_until_valid","content":"pub fn sort_until_valid(\n  page: List(Int),\n  rules: List(#(Int, Int)),\n) -&gt; List(Int)\n\nSynonyms:\nday_5.sort_until_valid\nday_5 sort_until_valid","url":"day_5.html#sort_until_valid"},{"doc":"day_5","title":"sum_middle_values","content":"pub fn sum_middle_values(pages: List(List(Int))) -&gt; Int\n\nSynonyms:\nday_5.sum_middle_values\nday_5 sum_middle_values","url":"day_5.html#sum_middle_values"},{"doc":"day_5","title":"swap","content":"pub fn swap(input: List(Int), a: Int, b: Int) -&gt; List(Int)\n\nSynonyms:\nday_5.swap\nday_5 swap","url":"day_5.html#swap"},{"doc":"day_5","title":"day_5","content":" To solve part 1, we create ordering rule from list of strings &quot;a|b&quot; where a needs to come before b\n\n Since numbers don&#39;t have to be in an ordering rule, we use the negation, so &quot;a|b&quot;\n results in a rule #(b, a), which, if violated, fails the check.\n To check for a list [a,b,c,d] we check the ordering for\n #(a, [b,c,d]), #(b, [c,d]) and #(c, [d])\n\n Part 2 is tricky. In general, the rules form a cyclic graph, which means we can&#39;t just\n flatten them to a pre-set order. Since this is a naive approach we run the risk of entering\n loops where the recursive solve function keeps swapping forever.\n\n We _could_ build some sort of per-element pre-solver to check which order we need to do the swaps\n in to get a valid page (which is NP-hard, and, more importantly, effort)\n orrrrrrr\n we just randomize the rules every time, lol","url":"day_5.html"},{"doc":"day_6","title":"check_grid_for_loop","content":"pub fn check_grid_for_loop(\n  grid: Dict(#(Int, Int), String),\n  guard: #(#(Int, Int), String),\n) -&gt; Bool\n\nSynonyms:\nday_6.check_grid_for_loop\nday_6 check_grid_for_loop","url":"day_6.html#check_grid_for_loop"},{"doc":"day_6","title":"find_guard","content":"pub fn find_guard(\n  grid: Dict(#(Int, Int), String),\n) -&gt; Result(#(#(Int, Int), String), Nil)\n\nSynonyms:\nday_6.find_guard\nday_6 find_guard","url":"day_6.html#find_guard"},{"doc":"day_6","title":"get_element_index","content":"pub fn get_element_index(\n  row: List(a),\n  element: a,\n) -&gt; Result(Int, Nil)\n\nSynonyms:\nday_6.get_element_index\nday_6 get_element_index","url":"day_6.html#get_element_index"},{"doc":"day_6","title":"get_grid_permutations","content":"pub fn get_grid_permutations(\n  grid: Dict(#(Int, Int), String),\n  original_grid: Dict(#(Int, Int), String),\n) -&gt; List(Dict(#(Int, Int), String))\n\nSynonyms:\nday_6.get_grid_permutations\nday_6 get_grid_permutations","url":"day_6.html#get_grid_permutations"},{"doc":"day_6","title":"get_guard_column","content":"pub fn get_guard_column(\n  grid: List(List(String)),\n  guard_row: List(String),\n) -&gt; List(String)\n\nSynonyms:\nday_6.get_guard_column\nday_6 get_guard_column","url":"day_6.html#get_guard_column"},{"doc":"day_6","title":"get_guard_list","content":"pub fn get_guard_list(\n  grid: List(List(String)),\n  guard: String,\n) -&gt; List(String)\n\nSynonyms:\nday_6.get_guard_list\nday_6 get_guard_list","url":"day_6.html#get_guard_list"},{"doc":"day_6","title":"get_guard_trail","content":"pub fn get_guard_trail(guard_char: String) -&gt; String\n\nSynonyms:\nday_6.get_guard_trail\nday_6 get_guard_trail","url":"day_6.html#get_guard_trail"},{"doc":"day_6","title":"get_next_guard_pos","content":"pub fn get_next_guard_pos(\n  guard: #(#(Int, Int), String),\n) -&gt; Result(#(Int, Int), Nil)\n\nSynonyms:\nday_6.get_next_guard_pos\nday_6 get_next_guard_pos","url":"day_6.html#get_next_guard_pos"},{"doc":"day_6","title":"has_guard","content":"pub fn has_guard(grid: List(List(String))) -&gt; Bool\n\nSynonyms:\nday_6.has_guard\nday_6 has_guard","url":"day_6.html#has_guard"},{"doc":"day_6","title":"is_forward_guard","content":"pub fn is_forward_guard(guard: String) -&gt; Bool\n\nSynonyms:\nday_6.is_forward_guard\nday_6 is_forward_guard","url":"day_6.html#is_forward_guard"},{"doc":"day_6","title":"is_vertical_guard","content":"pub fn is_vertical_guard(guard: String) -&gt; Bool\n\nSynonyms:\nday_6.is_vertical_guard\nday_6 is_vertical_guard","url":"day_6.html#is_vertical_guard"},{"doc":"day_6","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nday_6.main\nday_6 main","url":"day_6.html#main"},{"doc":"day_6","title":"move_guard","content":"pub fn move_guard(\n  grid: Dict(#(Int, Int), String),\n  guard: #(#(Int, Int), String),\n  target: #(Int, Int),\n) -&gt; Dict(#(Int, Int), String)\n\nSynonyms:\nday_6.move_guard\nday_6 move_guard","url":"day_6.html#move_guard"},{"doc":"day_6","title":"part_1","content":"pub fn part_1() -&gt; Int\n\nSynonyms:\nday_6.part_1\nday_6 part_1","url":"day_6.html#part_1"},{"doc":"day_6","title":"part_2","content":"pub fn part_2() -&gt; Int\n\nSynonyms:\nday_6.part_2\nday_6 part_2","url":"day_6.html#part_2"},{"doc":"day_6","title":"pretty_print","content":"pub fn pretty_print(\n  grid: Dict(#(Int, Int), String),\n) -&gt; Dict(#(Int, Int), String)\n\nSynonyms:\nday_6.pretty_print\nday_6 pretty_print","url":"day_6.html#pretty_print"},{"doc":"day_6","title":"rotate_guard","content":"pub fn rotate_guard(\n  grid: Dict(#(Int, Int), String),\n  guard: #(#(Int, Int), String),\n) -&gt; Dict(#(Int, Int), String)\n\nSynonyms:\nday_6.rotate_guard\nday_6 rotate_guard","url":"day_6.html#rotate_guard"},{"doc":"day_6","title":"rotate_guard_char","content":"pub fn rotate_guard_char(char: String) -&gt; String\n\nSynonyms:\nday_6.rotate_guard_char\nday_6 rotate_guard_char","url":"day_6.html#rotate_guard_char"},{"doc":"day_6","title":"row_contains_guard","content":"pub fn row_contains_guard(row: List(String)) -&gt; Bool\n\nSynonyms:\nday_6.row_contains_guard\nday_6 row_contains_guard","url":"day_6.html#row_contains_guard"},{"doc":"day_6","title":"should_create_permutation","content":"pub fn should_create_permutation(\n  grid: Dict(#(Int, Int), String),\n  coords: #(Int, Int),\n) -&gt; Bool\n\nSynonyms:\nday_6.should_create_permutation\nday_6 should_create_permutation","url":"day_6.html#should_create_permutation"},{"doc":"day_6","title":"solve_grid","content":"pub fn solve_grid(\n  grid: Dict(#(Int, Int), String),\n) -&gt; Dict(#(Int, Int), String)\n\nSynonyms:\nday_6.solve_grid\nday_6 solve_grid","url":"day_6.html#solve_grid"},{"doc":"day_6","title":"solve_grid_loops","content":"pub fn solve_grid_loops(\n  grid: Dict(#(Int, Int), String),\n  previously_seen_grids: List(Dict(#(Int, Int), String)),\n) -&gt; Result(Dict(#(Int, Int), String), Nil)\n\nSynonyms:\nday_6.solve_grid_loops\nday_6 solve_grid_loops","url":"day_6.html#solve_grid_loops"},{"doc":"day_6","title":"update_grid","content":"pub fn update_grid(\n  grid: Dict(#(Int, Int), String),\n  guard: #(#(Int, Int), String),\n) -&gt; Dict(#(Int, Int), String)\n\nSynonyms:\nday_6.update_grid\nday_6 update_grid","url":"day_6.html#update_grid"},{"doc":"day_6","title":"update_normalized_row","content":"pub fn update_normalized_row(row: List(String)) -&gt; List(String)\n\nSynonyms:\nday_6.update_normalized_row\nday_6 update_normalized_row","url":"day_6.html#update_normalized_row"},{"doc":"day_6","title":"will_loop","content":"pub fn will_loop(row: List(String)) -&gt; Bool\n\nSynonyms:\nday_6.will_loop\nday_6 will_loop","url":"day_6.html#will_loop"},{"doc":"day_6","title":"day_6","content":" This is being solved by a recursive function:\n\n If no &quot;&gt;&quot; or similar character is found, return the 2D array.\n Otherwise, find that character, check the direction its pointing, and then update the grid:\n - If it is pointing &quot;outside&quot;, so &quot;&gt;&quot; is at the right edge, etc., replace the character with &quot;.&quot;\n - If it is pointing at &quot;.&quot; or &quot;X&quot;, replace the arrow with &quot;X&quot; and the &quot;.&quot; with the arrow.\n - If it is pointing at &quot;#&quot;, rotate it by 90 degrees\n Then, call the function again with the updated grid.\n\n This also could benefit from using the shared `grid` module - it also should transform the\n individual directions in their own types instead of always comparing strings. You can see these\n sort of ideas develop in the later solutions, for now, I&#39;m a bit too lazy to refactor this.\n (Also it&#39;s a nice snapshot in time of my gleam-learning journey)","url":"day_6.html"},{"doc":"day_7","title":"get_operator_combinations","content":"pub fn get_operator_combinations(\n  input: List(Int),\n  num_operators: Int,\n) -&gt; List(List(fn(Int, Int) -&gt; Int))\n Encode n possible operators in m possible places\nSynonyms:\nday_7.get_operator_combinations\nday_7 get_operator_combinations","url":"day_7.html#get_operator_combinations"},{"doc":"day_7","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nday_7.main\nday_7 main","url":"day_7.html#main"},{"doc":"day_7","title":"parse_row","content":"pub fn parse_row(row: String) -&gt; #(Int, List(Int))\n\nSynonyms:\nday_7.parse_row\nday_7 parse_row","url":"day_7.html#parse_row"},{"doc":"day_7","title":"part_1","content":"pub fn part_1() -&gt; Int\n\nSynonyms:\nday_7.part_1\nday_7 part_1","url":"day_7.html#part_1"},{"doc":"day_7","title":"part_2","content":"pub fn part_2() -&gt; Int\n\nSynonyms:\nday_7.part_2\nday_7 part_2","url":"day_7.html#part_2"},{"doc":"day_7","title":"day_7","content":" The central idea of this is to represent each possible combination of n operators with\n an n-ary number.\n\n So for part 1, which only uses two operators, we can use a binary number:\n\n `1011` would represent the combination of `a + b * c + d + e`\n\n Part 2 uses three operators, so we can use a ternary number:\n\n `102` would represent the combination of `a + b * c &lt;concat&gt; d`\n\n This way, we can range over all possible combinations of operators and apply them to the input.\n\n Enumerating all possibilities isn&#39;t the most efficient way, but the `get_operator_combination`\n function is rather elegant.","url":"day_7.html"},{"doc":"day_8","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nday_8.main\nday_8 main","url":"day_8.html#main"},{"doc":"day_8","title":"day_8","content":"","url":"day_8.html"},{"doc":"day_9","title":"defragment","content":"pub fn defragment(\n  blocks: #(\n    Dict(Int, Int),\n    List(Int),\n    List(Int),\n    Dict(Int, #(Int, Int)),\n    Dict(Int, Int),\n  ),\n) -&gt; #(\n  Dict(Int, Int),\n  List(Int),\n  List(Int),\n  Dict(Int, #(Int, Int)),\n  Dict(Int, Int),\n)\n Reorder blocks so that the first gap key is larger than all content keys\nSynonyms:\nday_9.defragment\nday_9 defragment","url":"day_9.html#defragment"},{"doc":"day_9","title":"get_blocks","content":"pub fn get_blocks(\n  disk_map: String,\n) -&gt; #(\n  Dict(Int, Int),\n  List(Int),\n  List(Int),\n  Dict(Int, #(Int, Int)),\n  Dict(Int, Int),\n)\n Gets blocks from disk map\n Ints over 0 represent block ids, -1 represents free space\nSynonyms:\nday_9.get_blocks\nday_9 get_blocks","url":"day_9.html#get_blocks"},{"doc":"day_9","title":"get_checksum","content":"pub fn get_checksum(\n  blocks: #(\n    Dict(Int, Int),\n    List(Int),\n    List(Int),\n    Dict(Int, #(Int, Int)),\n    Dict(Int, Int),\n  ),\n) -&gt; Int\n\nSynonyms:\nday_9.get_checksum\nday_9 get_checksum","url":"day_9.html#get_checksum"},{"doc":"day_9","title":"get_content","content":"pub fn get_content(\n  blocks: #(\n    Dict(Int, Int),\n    List(Int),\n    List(Int),\n    Dict(Int, #(Int, Int)),\n    Dict(Int, Int),\n  ),\n) -&gt; List(Int)\n\nSynonyms:\nday_9.get_content\nday_9 get_content","url":"day_9.html#get_content"},{"doc":"day_9","title":"get_smallest_gap_key","content":"pub fn get_smallest_gap_key(\n  blocks: #(\n    Dict(Int, Int),\n    List(Int),\n    List(Int),\n    Dict(Int, #(Int, Int)),\n    Dict(Int, Int),\n  ),\n) -&gt; #(Int, List(Int))\n\nSynonyms:\nday_9.get_smallest_gap_key\nday_9 get_smallest_gap_key","url":"day_9.html#get_smallest_gap_key"},{"doc":"day_9","title":"is_defragmented","content":"pub fn is_defragmented(\n  blocks: #(\n    Dict(Int, Int),\n    List(Int),\n    List(Int),\n    Dict(Int, #(Int, Int)),\n    Dict(Int, Int),\n  ),\n) -&gt; Bool\n\nSynonyms:\nday_9.is_defragmented\nday_9 is_defragmented","url":"day_9.html#is_defragmented"},{"doc":"day_9","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nday_9.main\nday_9 main","url":"day_9.html#main"},{"doc":"day_9","title":"move_last_block_to_smallest_gap","content":"pub fn move_last_block_to_smallest_gap(\n  blocks: #(\n    Dict(Int, Int),\n    List(Int),\n    List(Int),\n    Dict(Int, #(Int, Int)),\n    Dict(Int, Int),\n  ),\n) -&gt; #(\n  Dict(Int, Int),\n  List(Int),\n  List(Int),\n  Dict(Int, #(Int, Int)),\n  Dict(Int, Int),\n)\n\nSynonyms:\nday_9.move_last_block_to_smallest_gap\nday_9 move_last_block_to_smallest_gap","url":"day_9.html#move_last_block_to_smallest_gap"},{"doc":"day_9","title":"part_1","content":"pub fn part_1() -&gt; Int\n\nSynonyms:\nday_9.part_1\nday_9 part_1","url":"day_9.html#part_1"},{"doc":"day_9","title":"part_2","content":"pub fn part_2() -&gt; List(Int)\n\nSynonyms:\nday_9.part_2\nday_9 part_2","url":"day_9.html#part_2"},{"doc":"day_9","title":"sort_by_key","content":"pub fn sort_by_key(a: #(Int, a), b: #(Int, a)) -&gt; Order\n\nSynonyms:\nday_9.sort_by_key\nday_9 sort_by_key","url":"day_9.html#sort_by_key"},{"doc":"day_9","title":"day_9","content":"","url":"day_9.html"},{"doc":"aoc_2024","title":"day_cmd","content":"pub fn day_cmd(day: Int) -&gt; Command(Nil)\n\nSynonyms:\naoc_2024.day_cmd\naoc_2024 day_cmd","url":"aoc_2024.html#day_cmd"},{"doc":"aoc_2024","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\naoc_2024.main\naoc_2024 main","url":"aoc_2024.html#main"},{"doc":"aoc_2024","title":"aoc_2024","content":" Solutions for Advent of Code 2024","url":"aoc_2024.html"}]);